#!/usr/bin/perl -T

use strict;
use warnings;

#*******************************************************************************
# Mentat::Reporter::Engine::Default module/class tests
#
# Author:   Jan Mach, jan.mach@cesnet.cz
# Version:  0.1
# Purpose:
#
#*******************************************************************************

use Data::Dumper;
#use Smart::Comments;

use Test::More tests => 3;

# First test if the module correctly compiles
BEGIN {
        use vars qw($TESTED_CLASS);
        $TESTED_CLASS = 'Mentat::Reporter::Engine::Default';

        use_ok('Tester');
        use_ok('Mentat::Reporter::Engine');
        use_ok($TESTED_CLASS);

        $ENV{PATH} = '/bin:/usr/bin';
    }

# Debug output explicit ON switch
Tester::DEBUG_ON();
#Tester::DEBUG_ON(10);

# Debug output explicit OFF switch
#Tester::DEBUG_OFF();

# User should know, which version is beeing tested (just for sure)
### $Mentat::Reporter::Engine::Default::VERSION

### Attempting to create Mentat::Reporter::Engine::Default instance...
my $instance = $TESTED_CLASS->new(filter_grammar_file => '../../conf/filter-grammar.conf',
                                  filter_schema_file  => '../../conf/schema-data-filter.json',
                                  filter_config       => '../../rules/filter/mentat-reporter-filter.json',
                                  template_dir        => '../../formater-templates',
                                  temp_folder         => './spool',
                                  charts_dir          => './spool',
                                  reports_dir         => './spool',
                                  event_database      => 'mentat',
                                  event_collection    => 'events',
                                  mail_from           => 'test@mentat.cesnet.cz',
                                  reply_to            => 'jan.mach@cesnet.cz',
                                  mail_admin          => 'jan.mach@cesnet.cz',
                                  mail_devel          => 'jan.mach@cesnet.cz',
                                  test_mode           => 1,
                                  dict => {
                                        'report_extra'   => 'Extra report',
                                        'report_summary' => 'Souhrnný report',
                                        'label_e'        => 'Jiný typ útoku/problému/události',
                                        'label_s'        => 'Jiné typy útoků/problémů/událostí',
                                    },
                                  pilot_mode => {
                                        'abuse@muni.cz' => 'rt@csirt-rt-devel.ics.muni.cz ',
                                        'abuse@zcu.cz'  => 'abuse@zcu.cz',
                                        'abuse@vsb.cz'  => 'abuse@vsb.cz',
                                    },
                                );
#isa_ok($instance, $TESTED_CLASS);

### Viewing the created instance: $instance
diag("Instance dump 01: " . Dumper($instance)) if Tester::D(2);

eval {
    #diag("*** Starting the processing\n");
    diag(Dumper($instance->process()));
    #diag("*** Processing done\n");
};
if ($@) {
    diag("$@\n");
}
