#!/usr/bin/perl -T

use strict;
use warnings;

#*******************************************************************************
# Mentat::Reporter::Fetcher::Default module/class tests
#
# Author:   Jan Mach, jan.mach@cesnet.cz
# Version:  0.1
# Purpose:
#
#*******************************************************************************

use Data::Dumper;
#use Smart::Comments;

use Test::More tests => 4;

# First test if the module correctly compiles
BEGIN {
        use vars qw($TESTED_CLASS);
        $TESTED_CLASS = 'Mentat::Reporter::Fetcher::Default';

        use_ok('Tester');
        use_ok('Mentat::Reporter::Fetcher');
        use_ok($TESTED_CLASS);

        $ENV{PATH} = '/bin:/usr/bin';
    }

# Debug output explicit ON switch
Tester::DEBUG_ON();
#Tester::DEBUG_ON(10);

# Debug output explicit OFF switch
#Tester::DEBUG_OFF();

# User should know, which version is beeing tested (just for sure)
### $Mentat::Reporter::Fetcher::Default::VERSION

### Attempting to create Mentat::Reporter::Fetcher::Default instance...
my $instance = $TESTED_CLASS->new(filter_grammar_file => '../../conf/filter-grammar.conf',
                                  filter_schema_file  => '../../conf/schema-data-filter.json',
                                  filter_config       => '../../rules/filter/mentat-reporter-filter.json',
                                  tl => time - (86400 * 7), th => time);
isa_ok($instance, $TESTED_CLASS);

### Viewing the created instance: $instance
diag("Instance dump 01: " . Dumper($instance)) if Tester::D(2);

diag("FAL:".Dumper($instance->fetch_abuse_list()));
diag("GAS:".Dumper($instance->get_severity_list()));
diag("GAL:".Dumper($instance->get_abuse_list()));

#diag(Dumper($instance->get_raw_data(time - 7200, time)));
diag(scalar @{$instance->get_raw_data(time - 7200, time)});

#diag(Dumper($instance->get_raw_data(time - 300, time)));
diag(scalar @{$instance->get_raw_data(time - 300, time)});


#diag(Dumper($instance->get_data(time - 7200, time, 'abuse@cesnet.cz', 'low')));
diag(scalar @{$instance->get_data(time - 7200, time, 'abuse@cesnet.cz', 'low')});

#diag(Dumper($instance->get_data(time - 300, time, 'abuse@cesnet.cz', 'low')));
diag(scalar @{$instance->get_data(time - 300, time, 'abuse@cesnet.cz', 'low')});

#diag(Dumper($instance->get_data(time - 7200, time, 'abuse@cesnet.cz', 'medium')));
diag(scalar @{$instance->get_data(time - 7200, time, 'abuse@cesnet.cz', 'medium')});

#diag(Dumper($instance->get_data(time - 300, time, 'abuse@cesnet.cz', 'medium')));
diag(scalar @{$instance->get_data(time - 300, time, 'abuse@cesnet.cz', 'medium')});

diag("Status: ".Dumper($instance->get_status()));
